<template>
  <div class="search-bar flex flex-center">
    <div class="dropdown-box flex flex-center">
      <div class="country-list">
        <select class="select-style" name="country" v-model="SearchCountry">
          <option value="">Select Country</option>
          <option
            :value="key"
            v-for="(list, key) in countryData"
            :key="key"
            :selected="key == SearchCountry ? true : false"
          >
            {{ list }}
          </option>
        </select>
      </div>
      <div class="category-list">
        <select class="select-style" name="category" v-model="SearchCategory">
          <option value="">Select Category</option>
          <option :value="key" v-for="(list, key) in categoryData" :key="key">
            {{ list }}
          </option>
        </select>
      </div>
      <div class="keywords-input">
        <input
          class="select-style setbox-input"
          type="text"
          placeholder="keywords (optional)"
          v-model="SearchQuery"
        />
      </div>
    </div>
    <div class="search-btn flex flex-center">
      <button
        class="flex flex-center"
        :disabled="handleDisable"
        @click="handleSearchData"
      >
        <i class="fa fa-search"></i>
      </button>
      <button class="flex flex-center">
        <i class="fa-solid fa-right-left"></i>
      </button>
    </div>
  </div>
</template>
<script>
import countryList from "../data/countries.json";
import categories from "../data/categories.json";
export default {
  name: "SearchBar",
  data() {
    return {
      SearchCountry: "",
      SearchCategory: "",
      SearchQuery: "",
      countryData: countryList,
      categoryData: categories,
    };
  },
  computed: {
    handleDisable() {
      return (this.SearchCategory && this.SearchCountry) || (this.SearchQuery && (this.SearchCategory=="" && this.SearchCountry==""))
        ? false
        : true;
    },
  },
  mounted() {
    const { country, category, search } = this.$store.getters.dropDownData;
    this.SearchQuery = search == "apple" ? "" : search;
    this.SearchCountry = country;
    this.SearchCategory = category;
  },
  methods: {
    handleSearchData() {
      if ((this.SearchCategory && this.SearchCountry) || this.SearchQuery) {
        this.$store.dispatch("PageSizeUpdate", 18);
        const data = {
          country: this.SearchCountry,
          category: this.SearchCategory,
          query: this.SearchQuery,
        };

        this.$store.dispatch("getNewsData", data);
      }
    },
  },
};
</script>

<style scoped>
.search-bar {
  width: 100%;
  background-color: #a8a8a8;
  height: 65px;
  column-gap: 1rem;

  position: sticky;
  top: 0;
}

.dropdown-box {
  height: 100%;
  width: 60%;
  column-gap: 0.5rem;
}

.country-list,
.category-list {
  width: 33%;
}

.country-list > select {
  width: 100%;
}

.category-list > select {
  width: 100%;
}

.setbox-input {
  padding: 1rem;
}

.select-style {
  height: 40px;
  border-radius: 0.2rem;
  box-shadow: 1px 2px 2px white;
  font-size: 12px;
  font-weight: 600;
  outline: none;
  border: none;
  box-sizing: border-box;
}

.keywords-input {
  width: 33%;
}

.keywords-input > input {
  width: 100%;
}

.search-btn {
  column-gap: 0.5rem;
}

.search-btn > button {
  background-color: black;
  color: white;
  padding: 1rem;
  border: none;
  height: 40px;
  font-size: 20px;
  border-radius: 0.2rem;
}
</style>
